[dpdk-dev] [PATCH] examples/l3fwd-power: fix build with gcc 4

2019-06-29 Thread Thomas Monjalon
error: ‘for’ loop initial declarations are only allowed in C99 mode

Fixes: 609e79841fcf ("examples/l3fwd-power: add telemetry mode")
Cc: reshma.pat...@intel.com

Signed-off-by: Thomas Monjalon 
---
 examples/l3fwd-power/main.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

diff --git a/examples/l3fwd-power/main.c b/examples/l3fwd-power/main.c
index fb2a9d62f..99c1208ce 100644
--- a/examples/l3fwd-power/main.c
+++ b/examples/l3fwd-power/main.c
@@ -2468,10 +2468,12 @@ main(int argc, char **argv)
rte_eal_mp_remote_launch(main_empty_poll_loop, NULL,
SKIP_MASTER);
} else {
+   unsigned int i;
+
/* Init metrics library */
rte_metrics_init(rte_socket_id());
/** Register stats with metrics library */
-   for (unsigned int i = 0; i < num_telstats; i++)
+   for (i = 0; i < num_telstats; i++)
ptr_strings[i] = telstats_strings[i].name;
 
ret = rte_metrics_reg_names(ptr_strings, num_telstats);
-- 
2.21.0



[dpdk-dev] [PATCH v2 02/10] devargs: remove incorrect experimental tags

2019-06-29 Thread David Marchand
The incriminated commit promoted those symbols as stable but the
prototypes still have the tag.

Fixes: 73eca2f77f4c ("devargs: promote experimental API as stable")
Cc: sta...@dpdk.org

Signed-off-by: David Marchand 
Acked-by: Adrien Mazarguil 
Acked-by: Stephen Hemminger 
Acked-by: Neil Horman 
---
 lib/librte_eal/common/include/rte_devargs.h | 2 --
 1 file changed, 2 deletions(-)

diff --git a/lib/librte_eal/common/include/rte_devargs.h 
b/lib/librte_eal/common/include/rte_devargs.h
index 89d9432..882dfa0 100644
--- a/lib/librte_eal/common/include/rte_devargs.h
+++ b/lib/librte_eal/common/include/rte_devargs.h
@@ -151,7 +151,6 @@ struct rte_devargs {
  *   - 0 on success
  *   - Negative on error.
  */
-__rte_experimental
 int
 rte_devargs_insert(struct rte_devargs **da);
 
@@ -183,7 +182,6 @@ struct rte_devargs {
  *   <0 on error.
  *   >0 if the devargs was not within the user device list.
  */
-__rte_experimental
 int rte_devargs_remove(struct rte_devargs *devargs);
 
 /**
-- 
1.8.3.1



[dpdk-dev] [PATCH v2 04/10] raw/dpaa2_qdma: remove incorrect experimental tag

2019-06-29 Thread David Marchand
The incriminated commit promoted this symbol as stable but the
prototype still has the tag.

Fixes: fb1a20331d70 ("raw/dpaa2_qdma: remove experimental tag from APIs")
Cc: sta...@dpdk.org

Signed-off-by: David Marchand 
Acked-by: Adrien Mazarguil 
Acked-by: Neil Horman 
---
 drivers/raw/dpaa2_qdma/rte_pmd_dpaa2_qdma.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/drivers/raw/dpaa2_qdma/rte_pmd_dpaa2_qdma.h 
b/drivers/raw/dpaa2_qdma/rte_pmd_dpaa2_qdma.h
index caf0293..a1f9050 100644
--- a/drivers/raw/dpaa2_qdma/rte_pmd_dpaa2_qdma.h
+++ b/drivers/raw/dpaa2_qdma/rte_pmd_dpaa2_qdma.h
@@ -286,7 +286,7 @@ struct rte_qdma_job {
  * @returns
  *   - A completed job or NULL if no job is there.
  */
-struct rte_qdma_job * __rte_experimental
+struct rte_qdma_job *
 rte_qdma_vq_dequeue(uint16_t vq_id);
 
 /**
-- 
1.8.3.1



[dpdk-dev] [PATCH v2 01/10] eal: hide internal hotplug symbol

2019-06-29 Thread David Marchand
This api was experimental and not properly marked in the map file.
But looking more closely, this is just an internal wrapper for EAL init.
Hide it in the hotplug code.

Fixes: 244d5130719c ("eal: enable hotplug on multi-process")
Cc: sta...@dpdk.org

Signed-off-by: David Marchand 
Acked-by: Adrien Mazarguil 
Acked-by: Stephen Hemminger 
Acked-by: Neil Horman 
---
 lib/librte_eal/common/hotplug_mp.c  | 2 +-
 lib/librte_eal/common/hotplug_mp.h  | 9 +
 lib/librte_eal/common/include/rte_eal.h | 9 -
 lib/librte_eal/linux/eal/eal.c  | 3 ++-
 4 files changed, 12 insertions(+), 11 deletions(-)

diff --git a/lib/librte_eal/common/hotplug_mp.c 
b/lib/librte_eal/common/hotplug_mp.c
index 4f316ba..ee79190 100644
--- a/lib/librte_eal/common/hotplug_mp.c
+++ b/lib/librte_eal/common/hotplug_mp.c
@@ -438,7 +438,7 @@ int eal_dev_hotplug_request_to_secondary(struct 
eal_dev_mp_req *req)
return 0;
 }
 
-int rte_mp_dev_hotplug_init(void)
+int eal_mp_dev_hotplug_init(void)
 {
int ret;
 
diff --git a/lib/librte_eal/common/hotplug_mp.h 
b/lib/librte_eal/common/hotplug_mp.h
index 597fde3..8fcf9b5 100644
--- a/lib/librte_eal/common/hotplug_mp.h
+++ b/lib/librte_eal/common/hotplug_mp.h
@@ -29,6 +29,15 @@ struct eal_dev_mp_req {
 };
 
 /**
+ * Register all mp action callbacks for hotplug.
+ *
+ * @return
+ *   0 on success, negative on error.
+ */
+int
+eal_mp_dev_hotplug_init(void);
+
+/**
  * This is a synchronous wrapper for secondary process send
  * request to primary process, this is invoked when an attach
  * or detach request is issued from primary process.
diff --git a/lib/librte_eal/common/include/rte_eal.h 
b/lib/librte_eal/common/include/rte_eal.h
index cf701e1..27808a3 100644
--- a/lib/librte_eal/common/include/rte_eal.h
+++ b/lib/librte_eal/common/include/rte_eal.h
@@ -409,15 +409,6 @@ typedef int (*rte_mp_async_reply_t)(const struct 
rte_mp_msg *request,
 rte_mp_reply(struct rte_mp_msg *msg, const char *peer);
 
 /**
- * Register all mp action callbacks for hotplug.
- *
- * @return
- *   0 on success, negative on error.
- */
-int __rte_experimental
-rte_mp_dev_hotplug_init(void);
-
-/**
  * Usage function typedef used by the application usage function.
  *
  * Use this function typedef to define and call 
rte_set_application_usage_hook()
diff --git a/lib/librte_eal/linux/eal/eal.c b/lib/librte_eal/linux/eal/eal.c
index aa0137e..8a0b387 100644
--- a/lib/librte_eal/linux/eal/eal.c
+++ b/lib/librte_eal/linux/eal/eal.c
@@ -59,6 +59,7 @@
 #include "eal_hugepages.h"
 #include "eal_options.h"
 #include "eal_vfio.h"
+#include "hotplug_mp.h"
 
 #define MEMSIZE_IF_NO_HUGE_PAGE (64ULL * 1024ULL * 1024ULL)
 
@@ -1062,7 +1063,7 @@ static void rte_eal_init_alert(const char *msg)
}
 
/* register multi-process action callbacks for hotplug */
-   if (rte_mp_dev_hotplug_init() < 0) {
+   if (eal_mp_dev_hotplug_init() < 0) {
rte_eal_init_alert("failed to register mp callback for 
hotplug");
return -1;
}
-- 
1.8.3.1



[dpdk-dev] [PATCH v2 00/10] experimental tags fixes

2019-06-29 Thread David Marchand
Here is a new series on __rte_experimental tags.

Following the build error reported by Aaron [1], I noticed that some
experimental functions could go unnoticed because of a gcc peculiarity.

To catch those, I went and added a new check on the object files to
ensure that any experimental api flagged in the map files is really
exported as such.

Then went with my previous idea of only adding the tags on the functions
prototypes and enforcing it (a new check in checkpatches.sh).
And finally enforcing that the __rte_experimental tag is always the first
part of a function prototype which seems to work with both gcc and clang.

Comments and reviews highly welcome :-).

Changelog since v1:
- rebased on master, caught newly introduced issues in eal
- added acks
- fixed telemetry issue
- squashed Adrien proposition in the last patch

[1]: http://mails.dpdk.org/archives/dev/2019-June/135365.html

-- 
David Marchand

David Marchand (10):
  eal: hide internal hotplug symbol
  devargs: remove incorrect experimental tags
  vfio: remove incorrect experimental tag
  raw/dpaa2_qdma: remove incorrect experimental tag
  buildtools: detect discrepancies for experimental symbols
  net/atlantic: add missing experimental api tags
  mem: remove incorrect experimental tag on static symbol
  telemetry: add missing header include
  remove experimental tags from all symbol definitions
  enforce __rte_experimental at the start of symbol declarations

 buildtools/check-experimental-syms.sh  | 29 ++--
 buildtools/map-list-symbol.sh  | 70 +++
 devtools/checkpatches.sh   | 38 +++
 doc/guides/contributing/versioning.rst |  6 +-
 drivers/net/atlantic/rte_pmd_atlantic.c| 12 ++--
 drivers/net/atlantic/rte_pmd_atlantic.h| 24 +++
 drivers/net/dpaa2/dpaa2_ethdev.c   |  2 +-
 drivers/net/ixgbe/rte_pmd_ixgbe.c  | 10 +--
 drivers/net/ixgbe/rte_pmd_ixgbe.h  | 15 +++--
 drivers/net/softnic/rte_eth_softnic.h  |  3 +-
 drivers/raw/dpaa2_qdma/rte_pmd_dpaa2_qdma.h|  2 +-
 lib/librte_bbdev/rte_bbdev.c   | 52 +++
 lib/librte_bbdev/rte_bbdev.h   | 72 +---
 lib/librte_bbdev/rte_bbdev_op.h| 18 +++--
 lib/librte_bbdev/rte_bbdev_pmd.h   | 12 ++--
 lib/librte_bpf/bpf.c   |  4 +-
 lib/librte_bpf/bpf_exec.c  |  4 +-
 lib/librte_bpf/bpf_load.c  |  4 +-
 lib/librte_bpf/bpf_load_elf.c  |  2 +-
 lib/librte_bpf/bpf_pkt.c   |  8 +--
 lib/librte_bpf/rte_bpf.h   | 18 +++--
 lib/librte_bpf/rte_bpf_ethdev.h| 12 ++--
 lib/librte_compressdev/rte_comp.c  | 12 ++--
 lib/librte_compressdev/rte_comp.h  | 18 +++--
 lib/librte_compressdev/rte_compressdev.c   | 50 +++---
 lib/librte_compressdev/rte_compressdev.h   | 66 --
 lib/librte_compressdev/rte_compressdev_pmd.c   |  6 +-
 lib/librte_compressdev/rte_compressdev_pmd.h   | 18 +++--
 lib/librte_cryptodev/rte_cryptodev.c   | 28 
 lib/librte_cryptodev/rte_cryptodev.h   | 42 
 lib/librte_eal/common/eal_common_class.c   |  6 +-
 lib/librte_eal/common/eal_common_dev.c |  8 +--
 lib/librte_eal/common/eal_common_fbarray.c | 52 +++
 lib/librte_eal/common/eal_common_log.c |  2 +-
 lib/librte_eal/common/eal_common_memory.c  | 50 +++---
 lib/librte_eal/common/eal_common_proc.c| 12 ++--
 lib/librte_eal/common/eal_common_timer.c   |  2 +-
 lib/librte_eal/common/hotplug_mp.c |  2 +-
 lib/librte_eal/common/hotplug_mp.h |  9 +++
 .../common/include/arch/x86/rte_atomic_64.h|  3 +-
 lib/librte_eal/common/include/generic/rte_atomic.h |  3 +-
 lib/librte_eal/common/include/generic/rte_cycles.h |  3 +-
 lib/librte_eal/common/include/generic/rte_rwlock.h |  6 +-
 .../common/include/generic/rte_ticketlock.h| 27 +---
 lib/librte_eal/common/include/rte_dev.h| 27 +---
 lib/librte_eal/common/include/rte_devargs.h|  2 -
 lib/librte_eal/common/include/rte_eal.h| 27 
 lib/librte_eal/common/include/rte_fbarray.h| 78 ++
 lib/librte_eal/common/include/rte_interrupts.h |  3 +-
 lib/librte_eal/common/include/rte_lcore.h  |  6 +-
 lib/librte_eal/common/include/rte_malloc.h | 30 ++---
 lib/librte_eal/common/include/rte_memory.h | 72 +---
 lib/librte_eal/common/include/rte_random.h |  3 +-
 lib/librte_eal/common/include/rte_service.h|  9 ++-
 lib/librte_eal/common/rte_malloc.c |  2 +-
 lib/librte_eal/common/

[dpdk-dev] [PATCH v2 03/10] vfio: remove incorrect experimental tag

2019-06-29 Thread David Marchand
The incriminated commit promoted this symbol as stable but the
definition still has the tag.

Fixes: 787ae736a3d9 ("vfio: remove experimental tag")
Cc: sta...@dpdk.org

Signed-off-by: David Marchand 
Acked-by: Adrien Mazarguil 
Acked-by: Stephen Hemminger 
Acked-by: Neil Horman 
---
 lib/librte_eal/linux/eal/eal_vfio.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/lib/librte_eal/linux/eal/eal_vfio.c 
b/lib/librte_eal/linux/eal/eal_vfio.c
index 6892a2c..feada64 100644
--- a/lib/librte_eal/linux/eal/eal_vfio.c
+++ b/lib/librte_eal/linux/eal/eal_vfio.c
@@ -1834,7 +1834,7 @@ struct spapr_walk_param {
return vfio_cfgs[i].vfio_container_fd;
 }
 
-int __rte_experimental
+int
 rte_vfio_container_destroy(int container_fd)
 {
struct vfio_config *vfio_cfg;
-- 
1.8.3.1



[dpdk-dev] [PATCH v2 06/10] net/atlantic: add missing experimental api tags

2019-06-29 Thread David Marchand
Those symbols are declared in the library map but the prototypes are
missing the experimental tag.
Without it, existing users won't notice it is experimental.

Fixes: ec0dec44ecb9 ("net/atlantic: enable MACsec configuration")
Cc: sta...@dpdk.org

Signed-off-by: David Marchand 
Acked-by: Adrien Mazarguil 
Acked-by: Neil Horman 
---
 drivers/net/atlantic/rte_pmd_atlantic.c | 12 ++--
 drivers/net/atlantic/rte_pmd_atlantic.h | 24 
 2 files changed, 30 insertions(+), 6 deletions(-)

diff --git a/drivers/net/atlantic/rte_pmd_atlantic.c 
b/drivers/net/atlantic/rte_pmd_atlantic.c
index 5bf4da2..2962f5c 100644
--- a/drivers/net/atlantic/rte_pmd_atlantic.c
+++ b/drivers/net/atlantic/rte_pmd_atlantic.c
@@ -8,7 +8,7 @@
 #include "atl_ethdev.h"
 
 
-__rte_experimental int
+int
 rte_pmd_atl_macsec_enable(uint16_t port,
  uint8_t encr, uint8_t repl_prot)
 {
@@ -24,7 +24,7 @@
return atl_macsec_enable(dev, encr, repl_prot);
 }
 
-__rte_experimental int
+int
 rte_pmd_atl_macsec_disable(uint16_t port)
 {
struct rte_eth_dev *dev;
@@ -39,7 +39,7 @@
return atl_macsec_disable(dev);
 }
 
-__rte_experimental int
+int
 rte_pmd_atl_macsec_config_txsc(uint16_t port, uint8_t *mac)
 {
struct rte_eth_dev *dev;
@@ -54,7 +54,7 @@
return atl_macsec_config_txsc(dev, mac);
 }
 
-__rte_experimental int
+int
 rte_pmd_atl_macsec_config_rxsc(uint16_t port, uint8_t *mac, uint16_t pi)
 {
struct rte_eth_dev *dev;
@@ -69,7 +69,7 @@
return atl_macsec_config_rxsc(dev, mac, pi);
 }
 
-__rte_experimental int
+int
 rte_pmd_atl_macsec_select_txsa(uint16_t port, uint8_t idx, uint8_t an,
 uint32_t pn, uint8_t *key)
 {
@@ -85,7 +85,7 @@
return atl_macsec_select_txsa(dev, idx, an, pn, key);
 }
 
-__rte_experimental int
+int
 rte_pmd_atl_macsec_select_rxsa(uint16_t port, uint8_t idx, uint8_t an,
 uint32_t pn, uint8_t *key)
 {
diff --git a/drivers/net/atlantic/rte_pmd_atlantic.h 
b/drivers/net/atlantic/rte_pmd_atlantic.h
index e4db7c6..c020856 100644
--- a/drivers/net/atlantic/rte_pmd_atlantic.h
+++ b/drivers/net/atlantic/rte_pmd_atlantic.h
@@ -14,6 +14,9 @@
 #include 
 
 /**
+ * @warning
+ * @b EXPERIMENTAL: this API may change, or be removed, without prior notice
+ *
  * Enable MACsec offload.
  *
  * @param port
@@ -29,9 +32,13 @@
  *   - (-ENODEV) if *port* invalid.
  *   - (-ENOTSUP) if hardware doesn't support this feature.
  */
+__rte_experimental
 int rte_pmd_atl_macsec_enable(uint16_t port, uint8_t encr, uint8_t repl_prot);
 
 /**
+ * @warning
+ * @b EXPERIMENTAL: this API may change, or be removed, without prior notice
+ *
  * Disable MACsec offload.
  *
  * @param port
@@ -41,9 +48,13 @@
  *   - (-ENODEV) if *port* invalid.
  *   - (-ENOTSUP) if hardware doesn't support this feature.
  */
+__rte_experimental
 int rte_pmd_atl_macsec_disable(uint16_t port);
 
 /**
+ * @warning
+ * @b EXPERIMENTAL: this API may change, or be removed, without prior notice
+ *
  * Configure Tx SC (Secure Connection).
  *
  * @param port
@@ -55,9 +66,13 @@
  *   - (-ENODEV) if *port* invalid.
  *   - (-ENOTSUP) if hardware doesn't support this feature.
  */
+__rte_experimental
 int rte_pmd_atl_macsec_config_txsc(uint16_t port, uint8_t *mac);
 
 /**
+ * @warning
+ * @b EXPERIMENTAL: this API may change, or be removed, without prior notice
+ *
  * Configure Rx SC (Secure Connection).
  *
  * @param port
@@ -71,9 +86,13 @@
  *   - (-ENODEV) if *port* invalid.
  *   - (-ENOTSUP) if hardware doesn't support this feature.
  */
+__rte_experimental
 int rte_pmd_atl_macsec_config_rxsc(uint16_t port, uint8_t *mac, uint16_t pi);
 
 /**
+ * @warning
+ * @b EXPERIMENTAL: this API may change, or be removed, without prior notice
+ *
  * Enable Tx SA (Secure Association).
  *
  * @param port
@@ -92,10 +111,14 @@
  *   - (-ENOTSUP) if hardware doesn't support this feature.
  *   - (-EINVAL) if bad parameter.
  */
+__rte_experimental
 int rte_pmd_atl_macsec_select_txsa(uint16_t port, uint8_t idx, uint8_t an,
   uint32_t pn, uint8_t *key);
 
 /**
+ * @warning
+ * @b EXPERIMENTAL: this API may change, or be removed, without prior notice
+ *
  * Enable Rx SA (Secure Association).
  *
  * @param port
@@ -114,6 +137,7 @@ int rte_pmd_atl_macsec_select_txsa(uint16_t port, uint8_t 
idx, uint8_t an,
  *   - (-ENOTSUP) if hardware doesn't support this feature.
  *   - (-EINVAL) if bad parameter.
  */
+__rte_experimental
 int rte_pmd_atl_macsec_select_rxsa(uint16_t port, uint8_t idx, uint8_t an,
   uint32_t pn, uint8_t *key);
 
-- 
1.8.3.1



[dpdk-dev] [PATCH v2 08/10] telemetry: add missing header include

2019-06-29 Thread David Marchand
Fixes: 1b756087db93 ("telemetry: add parser for client socket messages")
Cc: sta...@dpdk.org

Signed-off-by: David Marchand 
---
 lib/librte_telemetry/rte_telemetry_parser.c | 1 +
 1 file changed, 1 insertion(+)

diff --git a/lib/librte_telemetry/rte_telemetry_parser.c 
b/lib/librte_telemetry/rte_telemetry_parser.c
index e76382a..956d783 100644
--- a/lib/librte_telemetry/rte_telemetry_parser.c
+++ b/lib/librte_telemetry/rte_telemetry_parser.c
@@ -13,6 +13,7 @@
 #include 
 
 #include "rte_telemetry_internal.h"
+#include "rte_telemetry_parser.h"
 
 typedef int (*command_func)(struct telemetry_impl *, int, json_t *);
 
-- 
1.8.3.1



[dpdk-dev] [PATCH v2 07/10] mem: remove incorrect experimental tag on static symbol

2019-06-29 Thread David Marchand
This function is not visible from outside this code unit.

Fixes: 84e7477e10b1 ("mem: add thread unsafe version for DMA mask check")
Cc: sta...@dpdk.org

Signed-off-by: David Marchand 
Acked-by: Adrien Mazarguil 
Acked-by: Neil Horman 
---
 lib/librte_eal/common/eal_common_memory.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/lib/librte_eal/common/eal_common_memory.c 
b/lib/librte_eal/common/eal_common_memory.c
index 5ae8d01..de6fc1b 100644
--- a/lib/librte_eal/common/eal_common_memory.c
+++ b/lib/librte_eal/common/eal_common_memory.c
@@ -448,7 +448,7 @@ struct virtiova {
 #define MAX_DMA_MASK_BITS 63
 
 /* check memseg iovas are within the required range based on dma mask */
-static int __rte_experimental
+static int
 check_dma_mask(uint8_t maskbits, bool thread_unsafe)
 {
struct rte_mem_config *mcfg = rte_eal_get_configuration()->mem_config;
-- 
1.8.3.1



[dpdk-dev] [PATCH v2 05/10] buildtools: detect discrepancies for experimental symbols

2019-06-29 Thread David Marchand
When promoting those symbols as stable, there is no check to ensure that
the final result is consistent.

Add a little script to get the symbols per section from the library map
files.
Validate that all experimental symbols in object files are referenced by
library map files.

Signed-off-by: David Marchand 
Acked-by: Adrien Mazarguil 
Acked-by: Neil Horman 
---
 buildtools/check-experimental-syms.sh | 29 +++
 buildtools/map-list-symbol.sh | 70 +++
 2 files changed, 92 insertions(+), 7 deletions(-)
 create mode 100755 buildtools/map-list-symbol.sh

diff --git a/buildtools/check-experimental-syms.sh 
b/buildtools/check-experimental-syms.sh
index 7d1f3a5..653756e 100755
--- a/buildtools/check-experimental-syms.sh
+++ b/buildtools/check-experimental-syms.sh
@@ -5,6 +5,8 @@
 MAPFILE=$1
 OBJFILE=$2
 
+LIST_SYMBOL=$RTE_SDK/buildtools/map-list-symbol.sh
+
 # added check for "make -C test/" usage
 if [ ! -e $MAPFILE ] || [ ! -f $OBJFILE ]
 then
@@ -16,12 +18,9 @@ then
exit 0
 fi
 
-for i in `awk 'BEGIN {found=0}
-   /.*EXPERIMENTAL.*/ {found=1}
-   /.*}.*;/ {found=0}
-   /.*;/ {if (found == 1) print $1}' $MAPFILE`
+ret=0
+for SYM in `$LIST_SYMBOL -S EXPERIMENTAL $MAPFILE`
 do
-   SYM=`echo $i | sed -e"s/;//"`
objdump -t $OBJFILE | grep -q "\.text.*$SYM$"
IN_TEXT=$?
objdump -t $OBJFILE | grep -q "\.text\.experimental.*$SYM$"
@@ -33,8 +32,24 @@ do
but is listed in version map
Please add __rte_experimental to the definition of $SYM
END_OF_MESSAGE
-   exit 1
+   ret=1
fi
 done
-exit 0
 
+for SYM in `objdump -t $OBJFILE |awk '{
+   if ($2 != "l" && $4 == ".text.experimental") {
+   print $NF
+   }
+}'`
+do
+   $LIST_SYMBOL -S EXPERIMENTAL -s $SYM -q $MAPFILE || {
+   cat >&2 <<- END_OF_MESSAGE
+   $SYM is flagged as experimental
+   but is not listed in version map
+   Please add $SYM to the version map
+   END_OF_MESSAGE
+   ret=1
+   }
+done
+
+exit $ret
diff --git a/buildtools/map-list-symbol.sh b/buildtools/map-list-symbol.sh
new file mode 100755
index 000..5509b4a
--- /dev/null
+++ b/buildtools/map-list-symbol.sh
@@ -0,0 +1,70 @@
+#!/bin/sh
+# SPDX-License-Identifier: BSD-3-Clause
+# Copyright(c) 2018 David Marchand 
+
+section=all
+symbol=all
+quiet=
+
+while getopts 'S:s:q' name; do
+   case $name in
+   S)
+   [ $section = 'all' ] || {
+   echo 'Cannot list in multiple sections'
+   exit 1
+   }
+   section=$OPTARG
+   ;;
+   s)
+   [ $symbol = 'all' ] || {
+   echo 'Cannot list multiple symbols'
+   exit 1
+   }
+   symbol=$OPTARG
+   ;;
+   q)
+   quiet='y'
+   ;;
+   ?)
+   echo 'usage: $0 [-S section] [-s symbol] [-q]'
+   exit 1
+   ;;
+   esac
+done
+
+shift $(($OPTIND - 1))
+
+for file in $@; do
+   cat "$file" |awk '
+   BEGIN {
+   current_section = "";
+   if ("'$section'" == "all" && "'$symbol'" == "all") {
+   ret = 0;
+   } else {
+   ret = 1;
+   }
+   }
+   /^.*{/ {
+   if ("'$section'" == "all" || $1 == "'$section'") {
+   current_section = $1;
+   }
+   }
+   /.*}/ { current_section = ""; }
+   /^[^}].*[^:*];/ {
+   if (current_section != "") {
+   gsub(";","");
+   if ("'$symbol'" == "all" || $1 == "'$symbol'") {
+   ret = 0;
+   if ("'$quiet'" == "") {
+   print "'$file' "current_section" "$1;
+   }
+   if ("'$symbol'" != "all") {
+   exit 0;
+   }
+   }
+   }
+   }
+   END {
+   exit ret;
+   }'
+done
-- 
1.8.3.1



[dpdk-dev] [PATCH v2 09/10] remove experimental tags from all symbol definitions

2019-06-29 Thread David Marchand
We had some inconsistencies between functions prototypes and actual
definitions.
Let's avoid this by only adding the experimental tag to the prototypes.
Tests with gcc and clang show it is enough.

git grep -l __rte_experimental |grep \.c$ |while read file; do
sed -i -e '/^__rte_experimental$/d' $file;
sed -i -e 's/  *__rte_experimental//' $file;
sed -i -e 's/__rte_experimental  *//' $file;
done

Signed-off-by: David Marchand 
Acked-by: Adrien Mazarguil 
Acked-by: Neil Horman 
---
Changelog since v1:
- fixed checkpatch warning
- fixed rte_random new symbol

---
 devtools/checkpatches.sh   | 33 
 doc/guides/contributing/versioning.rst |  6 +--
 drivers/net/dpaa2/dpaa2_ethdev.c   |  2 +-
 drivers/net/ixgbe/rte_pmd_ixgbe.c  | 10 ++---
 lib/librte_bbdev/rte_bbdev.c   | 52 +-
 lib/librte_bpf/bpf.c   |  4 +-
 lib/librte_bpf/bpf_exec.c  |  4 +-
 lib/librte_bpf/bpf_load.c  |  4 +-
 lib/librte_bpf/bpf_load_elf.c  |  2 +-
 lib/librte_bpf/bpf_pkt.c   |  8 ++--
 lib/librte_compressdev/rte_comp.c  | 12 +++---
 lib/librte_compressdev/rte_compressdev.c   | 50 -
 lib/librte_compressdev/rte_compressdev_pmd.c   |  6 +--
 lib/librte_cryptodev/rte_cryptodev.c   | 28 +++---
 lib/librte_eal/common/eal_common_class.c   |  6 +--
 lib/librte_eal/common/eal_common_dev.c |  8 ++--
 lib/librte_eal/common/eal_common_fbarray.c | 52 +-
 lib/librte_eal/common/eal_common_log.c |  2 +-
 lib/librte_eal/common/eal_common_memory.c  | 48 
 lib/librte_eal/common/eal_common_proc.c| 12 +++---
 lib/librte_eal/common/eal_common_timer.c   |  2 +-
 lib/librte_eal/common/rte_malloc.c |  2 +-
 lib/librte_eal/common/rte_option.c |  1 -
 lib/librte_eal/common/rte_random.c |  2 +-
 lib/librte_eal/common/rte_service.c|  6 +--
 lib/librte_eal/freebsd/eal/eal.c   |  2 +-
 lib/librte_eal/freebsd/eal/eal_dev.c   |  8 ++--
 lib/librte_eal/freebsd/eal/eal_interrupts.c|  2 +-
 lib/librte_eal/linux/eal/eal_dev.c |  8 ++--
 lib/librte_eal/linux/eal/eal_interrupts.c  |  2 +-
 lib/librte_ethdev/rte_ethdev.c | 28 +++---
 lib/librte_ethdev/rte_flow.c   |  2 +-
 lib/librte_ethdev/rte_mtr.c| 24 ++--
 lib/librte_eventdev/rte_event_eth_rx_adapter.c |  4 +-
 lib/librte_flow_classify/rte_flow_classify.c   | 14 +++
 lib/librte_hash/rte_cuckoo_hash.c  |  2 +-
 lib/librte_ip_frag/rte_ip_frag_common.c|  2 +-
 lib/librte_ipsec/sa.c  |  8 ++--
 lib/librte_ipsec/ses.c |  2 +-
 lib/librte_kni/rte_kni.c   |  2 +-
 lib/librte_kvargs/rte_kvargs.c |  2 -
 lib/librte_mbuf/rte_mbuf.c |  1 -
 lib/librte_meter/rte_meter.c   |  4 +-
 lib/librte_net/rte_arp.c   |  2 +-
 lib/librte_net/rte_net.c   |  2 +-
 lib/librte_power/rte_power_empty_poll.c| 14 +++
 lib/librte_rcu/rte_rcu_qsbr.c  | 12 +++---
 lib/librte_sched/rte_sched.c   |  2 +-
 lib/librte_security/rte_security.c |  6 +--
 lib/librte_telemetry/rte_telemetry.c   |  6 +--
 lib/librte_telemetry/rte_telemetry_parser.c|  2 +-
 lib/librte_timer/rte_timer.c   | 16 
 lib/librte_vhost/vdpa.c|  2 +-
 lib/librte_vhost/vhost_crypto.c| 10 ++---
 54 files changed, 289 insertions(+), 264 deletions(-)

diff --git a/devtools/checkpatches.sh b/devtools/checkpatches.sh
index 6a01b39..d150353 100755
--- a/devtools/checkpatches.sh
+++ b/devtools/checkpatches.sh
@@ -79,6 +79,31 @@ check_forbidden_additions() { # 
return $res
 }
 
+check_experimental_tags() { # 
+   res=0
+
+   cat "$1" |awk '
+   BEGIN {
+   current_file = "";
+   ret = 0;
+   }
+   /^+++ b\// {
+   current_file = $2;
+   }
+   /^+.*__rte_experimental/ {
+   if (current_file ~ ".c$" ) {
+   print "Please only put __rte_experimental tags in " \
+   "headers ("current_file")";
+   ret = 1;
+   }
+   }
+   END {
+   exit ret;
+   }' || res=1
+
+   return $res
+}
+
 number=0
 range='origin/master..'
 quiet=false
@@ -151,6 +176,14 @@ check () { #   
ret=1
fi
 
+   ! $verbose || printf '\nChecking __rte_experimental tags:\n'
+   report=$(check_experimental_tags "$tmpinput")
+   if [ $? -ne 0 ] ; then
+   $headline_printed || prin

[dpdk-dev] [PATCH v2 10/10] enforce __rte_experimental at the start of symbol declarations

2019-06-29 Thread David Marchand
Putting a '__attribute__((deprecated))' in the middle of a function
prototype does not result in the expected result with gcc (while clang
is fine with this syntax).

$ cat deprecated.c
void * __attribute__((deprecated)) incorrect() { return 0; }
__attribute__((deprecated)) void *correct(void) { return 0; }
int main(int argc, char *argv[]) { incorrect(); correct(); return 0; }
$ gcc -o deprecated.o -c deprecated.c
deprecated.c: In function ‘main’:
deprecated.c:3:1: warning: ‘correct’ is deprecated (declared at
deprecated.c:2) [-Wdeprecated-declarations]
 int main(int argc, char *argv[]) { incorrect(); correct(); return 0; }
 ^

Move the tag on a separate line and make it the first thing of function
prototypes.
This is not perfect but we will trust reviewers to catch the other not
so easy to detect patterns.

sed -i \
 -e '/^\([^#].*\)\?__rte_experimental */{' \
 -e 's//\1/; s/ *$//; i\' \
 -e __rte_experimental \
 -e '/^$/d}' \
 $(git grep -l __rte_experimental -- '*.h')

Special mention for rte_mbuf_data_addr_default():

There is either a bug or a (not yet understood) issue with gcc.
gcc won't drop this inline when unused and rte_mbuf_data_addr_default()
calls rte_mbuf_buf_addr() which itself is experimental.
This results in a build warning when not accepting experimental apis
from sources just including rte_mbuf.h.

For this specific case, we hide the call to rte_mbuf_buf_addr() under
the ALLOW_EXPERIMENTAL_API flag.

Signed-off-by: Adrien Mazarguil 
Signed-off-by: David Marchand 
---
Changelog since v1:
- fixed new rte_random symbol
- squashed Adrien proposal into my first patch [1]

1: http://mails.dpdk.org/archives/dev/2019-June/136295.html

---
 devtools/checkpatches.sh   |  5 ++
 drivers/net/ixgbe/rte_pmd_ixgbe.h  | 15 +++--
 drivers/net/softnic/rte_eth_softnic.h  |  3 +-
 lib/librte_bbdev/rte_bbdev.h   | 72 +---
 lib/librte_bbdev/rte_bbdev_op.h| 18 +++--
 lib/librte_bbdev/rte_bbdev_pmd.h   | 12 ++--
 lib/librte_bpf/rte_bpf.h   | 18 +++--
 lib/librte_bpf/rte_bpf_ethdev.h| 12 ++--
 lib/librte_compressdev/rte_comp.h  | 18 +++--
 lib/librte_compressdev/rte_compressdev.h   | 66 --
 lib/librte_compressdev/rte_compressdev_pmd.h   | 18 +++--
 lib/librte_cryptodev/rte_cryptodev.h   | 42 
 .../common/include/arch/x86/rte_atomic_64.h|  3 +-
 lib/librte_eal/common/include/generic/rte_atomic.h |  3 +-
 lib/librte_eal/common/include/generic/rte_cycles.h |  3 +-
 lib/librte_eal/common/include/generic/rte_rwlock.h |  6 +-
 .../common/include/generic/rte_ticketlock.h| 27 +---
 lib/librte_eal/common/include/rte_dev.h| 27 +---
 lib/librte_eal/common/include/rte_eal.h| 18 +++--
 lib/librte_eal/common/include/rte_fbarray.h| 78 ++
 lib/librte_eal/common/include/rte_interrupts.h |  3 +-
 lib/librte_eal/common/include/rte_lcore.h  |  6 +-
 lib/librte_eal/common/include/rte_malloc.h | 30 ++---
 lib/librte_eal/common/include/rte_memory.h | 72 +---
 lib/librte_eal/common/include/rte_random.h |  3 +-
 lib/librte_eal/common/include/rte_service.h|  9 ++-
 lib/librte_ethdev/rte_ethdev.h | 36 ++
 lib/librte_ethdev/rte_ethdev_driver.h  | 15 +++--
 lib/librte_ethdev/rte_flow_driver.h|  3 +-
 lib/librte_ethdev/rte_mtr.h| 36 ++
 lib/librte_eventdev/rte_event_eth_rx_adapter.h |  6 +-
 lib/librte_flow_classify/rte_flow_classify.h   | 21 --
 lib/librte_hash/rte_hash.h |  3 +-
 lib/librte_ip_frag/rte_ip_frag.h   |  3 +-
 lib/librte_ipsec/rte_ipsec.h   |  9 ++-
 lib/librte_ipsec/rte_ipsec_group.h |  6 +-
 lib/librte_ipsec/rte_ipsec_sa.h| 12 ++--
 lib/librte_kni/rte_kni.h   |  3 +-
 lib/librte_mbuf/rte_mbuf.h | 18 +++--
 lib/librte_meter/rte_meter.h   | 18 +++--
 lib/librte_net/rte_arp.h   |  3 +-
 lib/librte_net/rte_net.h   |  3 +-
 lib/librte_pipeline/rte_port_in_action.h   | 24 ---
 lib/librte_pipeline/rte_table_action.h | 48 -
 lib/librte_power/rte_power_empty_poll.h| 21 --
 lib/librte_rcu/rte_rcu_qsbr.h  | 39 +++
 lib/librte_sched/rte_sched.h   |  3 +-
 lib/librte_security/rte_security.h |  9 ++-
 lib/librte_stack/rte_stack.h   | 21 --
 lib/librte_stack/rte_stack_lf.h|  6 +-
 lib/librte_stack/rte_stack_std.h   |  9 ++-
 lib/librte_table/rte_table_hash_func.h  

Re: [dpdk-dev] [dpdk-stable] [PATCH v3 1/2] test/rcu: increase the size of num cores variable

2019-06-29 Thread Thomas Monjalon
28/06/2019 20:54, David Marchand:
> On Fri, Jun 28, 2019 at 8:44 PM Honnappa Nagarahalli <
> honnappa.nagaraha...@arm.com> wrote:
> 
> > num_cores is of type uint8_t. This results in the following
> > compilation error.
> >
> > test_rcu_qsbr_perf.c:649:16: error: comparison is always false
> > due to limited range of data type [-Werror=type-limits]
> >   if (num_cores >= RTE_MAX_LCORE) {
> > ^~
> >
> > RTE_MAX_LCORE is set to 256 for armv8 config.
> >
> > Fixes: e6a14121f4ae ("test/rcu: remove arbitrary limit on max core count")
> > Cc: sta...@dpdk.org
> >
> > Signed-off-by: Honnappa Nagarahalli 
> > Reviewed-by: Ruifeng Wang 
> 
> Thanks.
> Reviewed-by: David Marchand 

Series applied, thanks




Re: [dpdk-dev] [PATCH] examples/l3fwd-power: fix build with gcc 4

2019-06-29 Thread Thomas Monjalon
29/06/2019 10:55, Thomas Monjalon:
> error: ‘for’ loop initial declarations are only allowed in C99 mode
> 
> Fixes: 609e79841fcf ("examples/l3fwd-power: add telemetry mode")
> Cc: reshma.pat...@intel.com
> 
> Signed-off-by: Thomas Monjalon 

Applied quickly in the hope of getting CI in a stable state.





Re: [dpdk-dev] [PATCH] eal: use 32-bit RDSEED to allow 32-bit x86 usage

2019-06-29 Thread Thomas Monjalon
28/06/2019 23:08, Mattias Rönnblom:
> When seeding the pseudo-random number generator, replace the 64-bit
> RDSEED with two 32-bit RDSEED instructions to allow building and
> running on 32-bit x86.
> 
> Fixes: faf8fd252785 ("eal: improve entropy for initial PRNG seed")
> 
> Reported-by: Ferruh Yigit 
> Signed-off-by: Mattias Rönnblom 

Applied, thanks




Re: [dpdk-dev] [PATCH v2 10/10] enforce __rte_experimental at the start of symbol declarations

2019-06-29 Thread Thomas Monjalon
29/06/2019 13:58, David Marchand:
> Special mention for rte_mbuf_data_addr_default():
> 
> There is either a bug or a (not yet understood) issue with gcc.
> gcc won't drop this inline when unused and rte_mbuf_data_addr_default()
> calls rte_mbuf_buf_addr() which itself is experimental.
> This results in a build warning when not accepting experimental apis
> from sources just including rte_mbuf.h.
> 
> For this specific case, we hide the call to rte_mbuf_buf_addr() under
> the ALLOW_EXPERIMENTAL_API flag.
[...]
> -static inline char * __rte_experimental
> -rte_mbuf_data_addr_default(struct rte_mbuf *mb)
> +__rte_experimental
> +static inline char *
> +rte_mbuf_data_addr_default(struct rte_mbuf *mb __rte_unused)
>  {
> + /* gcc complains about calling this experimental function even
> +  * when not using it. Hide it with ALLOW_EXPERIMENTAL_API.
> +  */
> +#ifdef ALLOW_EXPERIMENTAL_API
>   return rte_mbuf_buf_addr(mb, mb->pool) + RTE_PKTMBUF_HEADROOM;
> +#else
> + return NULL;
> +#endif
>  }

Doxygen is confused by having __rte_unused at the end:

lib/librte_mbuf/rte_mbuf.h:876: warning:
argument 'mb' of command @param is not found in the argument list of
rte_mbuf_data_addr_default(struct rte_mbuf *mb __rte_unused)
lib/librte_mbuf/rte_mbuf.h:889: warning:
The following parameters of
rte_mbuf_data_addr_default(struct rte_mbuf *mb __rte_unused)
are not documented:
parameter '__rte_unused'

I move __rte_unused at the beginning while merging.




Re: [dpdk-dev] [PATCH v2 10/10] enforce __rte_experimental at the start of symbol declarations

2019-06-29 Thread David Marchand
On Sat, Jun 29, 2019 at 6:14 PM Thomas Monjalon  wrote:

> 29/06/2019 13:58, David Marchand:
> > Special mention for rte_mbuf_data_addr_default():
> >
> > There is either a bug or a (not yet understood) issue with gcc.
> > gcc won't drop this inline when unused and rte_mbuf_data_addr_default()
> > calls rte_mbuf_buf_addr() which itself is experimental.
> > This results in a build warning when not accepting experimental apis
> > from sources just including rte_mbuf.h.
> >
> > For this specific case, we hide the call to rte_mbuf_buf_addr() under
> > the ALLOW_EXPERIMENTAL_API flag.
> [...]
> > -static inline char * __rte_experimental
> > -rte_mbuf_data_addr_default(struct rte_mbuf *mb)
> > +__rte_experimental
> > +static inline char *
> > +rte_mbuf_data_addr_default(struct rte_mbuf *mb __rte_unused)
> >  {
> > + /* gcc complains about calling this experimental function even
> > +  * when not using it. Hide it with ALLOW_EXPERIMENTAL_API.
> > +  */
> > +#ifdef ALLOW_EXPERIMENTAL_API
> >   return rte_mbuf_buf_addr(mb, mb->pool) + RTE_PKTMBUF_HEADROOM;
> > +#else
> > + return NULL;
> > +#endif
> >  }
>
> Doxygen is confused by having __rte_unused at the end:
>
> lib/librte_mbuf/rte_mbuf.h:876: warning:
> argument 'mb' of command @param is not found in the argument list
> of
> rte_mbuf_data_addr_default(struct rte_mbuf *mb __rte_unused)
> lib/librte_mbuf/rte_mbuf.h:889: warning:
> The following parameters of
> rte_mbuf_data_addr_default(struct rte_mbuf *mb __rte_unused)
> are not documented:
> parameter '__rte_unused'
>
> I move __rte_unused at the beginning while merging.
>

Indeed.
Thanks for catching and fixing.


Consequently, could we have the documentation (html only?) generated in the
CI if it is not too time consuming.
WDYT Aaron, Michael?



-- 
David Marchand


Re: [dpdk-dev] [PATCH v2 00/10] experimental tags fixes

2019-06-29 Thread Thomas Monjalon
29/06/2019 13:58, David Marchand:
> Following the build error reported by Aaron [1], I noticed that some
> experimental functions could go unnoticed because of a gcc peculiarity.
> 
> To catch those, I went and added a new check on the object files to
> ensure that any experimental api flagged in the map files is really
> exported as such.
> 
> Then went with my previous idea of only adding the tags on the functions
> prototypes and enforcing it (a new check in checkpatches.sh).
> And finally enforcing that the __rte_experimental tag is always the first
> part of a function prototype which seems to work with both gcc and clang.

Applied, thanks




Re: [dpdk-dev] [PATCH v3 3/3] lib/lpm: memory orderings to avoid race conditions for v20

2019-06-29 Thread Honnappa Nagarahalli


> 
> As a general remark consider writing all of the tbl entries including
> tbl8 with atomic_store. Now "lpm->tbl8[j] = new_tbl8_entry;" is looks like
> 
>   1e9:   44 88 9c 47 40 01 00    mov
> %r11b,0x2000140(%rdi,%rax,2) <-write first byte
>   1f0:   02
>   1f1:   48 83 c0 01 add    $0x1,%rax
>   1f5:   42 88 8c 47 41 01 00    mov %cl,0x2000141(%rdi,%r8,2) <-write
> second byte
>   1fc:   02
> 
> This may cause an incorrect nexthop to be returned. If the byte with valid 
> flag
> is updated first, the old(and maybe invalid) next hop could be returned.
+1

It is surprising that the compiler is not generating a single 32b store. As you 
mentioned 'relaxed' __atomic_store_n should be good.

> 
> Please evaluate performance drop after.
> 
> --
> Regards,
> Vladimir



Re: [dpdk-dev] [PATCH v2] eal: fix positive error codes from probe/remove

2019-06-29 Thread Thomas Monjalon
07/06/2019 10:32, David Marchand:
> On Thu, Jun 6, 2019 at 12:03 PM Ilya Maximets 
> wrote:
> 
> > According to API, 'rte_dev_probe()' and 'rte_dev_remove()' must
> > return 0 or negative error code. Bus code returns positive values
> > if device wasn't recognized by any driver, so the result of
> > 'bus->plug/unplug()' must be converted. 'local_dev_probe()' and
> > 'local_dev_remove()' also has their internal API, so the conversion
> > should be done there.
> >
> > Positive on remove means that device not found by driver.
> >
> 
> For backports, it is safer to add the check on > 0.
> The patch looks good to me.
> 
> Reviewed-by: David Marchand 

Applied, thanks





[dpdk-dev] aligned commit logs

2019-06-29 Thread Thomas Monjalon
Hi Ivan,

I'm curious about the alignment of your commit logs.
How do you manage to fit in such a beautiful alignment?
Is it a challenge to win something? :)

References:
http://dpdk.org/commit/42319ff3e0
http://dpdk.org/commit/64efa6f85d
http://dpdk.org/commit/f5f93e106e
http://dpdk.org/commit/86dbbc5dbb
http://dpdk.org/commit/b65eb10c4d
http://dpdk.org/commit/d1482e21f0
http://dpdk.org/commit/5e23c24988
http://dpdk.org/commit/7a1ab3f8db
http://dpdk.org/commit/b22e77c026
http://dpdk.org/commit/7106c99cb8
http://dpdk.org/commit/c78d280e88
http://dpdk.org/commit/85069adea7
http://dpdk.org/commit/cd8da5e83d
http://dpdk.org/commit/7482984419
http://dpdk.org/commit/b8afc069fa
http://dpdk.org/commit/642088ddff
http://dpdk.org/commit/d112a3ecb7
http://dpdk.org/commit/3b257f7e6c
http://dpdk.org/commit/4650ed44c1
http://dpdk.org/commit/f5258439ee
http://dpdk.org/commit/178fc0d327
http://dpdk.org/commit/e56fa9c23e
http://dpdk.org/commit/e9ddf37a50






[dpdk-dev] Setting jumbo MTU on vmxnet3

2019-06-29 Thread Prahasur
Hi,
I am trying to set jumbo MTU on vmxnet3 but I see that
rte_eth_dev_set_mtu() is not implemented by the vmxnet3 drivers. Is
there any other way to set it?


Re: [dpdk-dev] [PATCH v3] net/i40e: fix core dumped when setting txq or rxq to 0 in VF

2019-06-29 Thread Zhang, Qi Z
Hi Andy:

> -Original Message-
> From: Pei, Andy
> Sent: Friday, June 21, 2019 5:23 PM
> To: dev@dpdk.org
> Cc: Pei, Andy ; Zhang, Helin ;
> sta...@dpdk.org; Zhang, Roy Fan ; Zhang, Qi Z
> ; Wu, Jingjing ; Xing, Beilei
> ; Yigit, Ferruh ; Xu, Rosen
> ; Ye, Xiaolong 
> Subject: [PATCH v3] net/i40e: fix core dumped when setting txq or rxq to 0 in
> VF
> 
> Testpmd would stuck and result in core dump when user specifies an invalid
> VF queue number. This patch fixes this issue.

Is that the case, dev_start will core dump due to violate memory access if rxq 
or txq number is 0?
It's better to have a more specific description of the issue..

> 
> Fixes: d6b19729093e ("i40evf: support configurable crc stripping")
> Cc: helin.zh...@intel.com
> Cc: sta...@dpdk.org
> 
> Signed-off-by: Andy Pei 
> ---
> v3:
> * no need to use a new line for each parameter when call envoke a
>   function. A new line comes when the current line is more than
>   80 characters.
> 
> v2:
>  * modify commit meaasage so one line contains not more than 72
>characters.
>  * delete unnecessary parentheses around 'queue_id < nb_txq'
>  * delete unnecessary parentheses around 'queue_id < nb_rxq'
> 
> Cc: roy.fan.zh...@intel.com
> Cc: qi.z.zh...@intel.com
> Cc: jingjing...@intel.com
> Cc: beilei.x...@intel.com
> Cc: ferruh.yi...@intel.com
> Cc: rosen...@intel.com
> Cc: xiaolong...@intel.com
> 
>  drivers/net/i40e/i40e_ethdev_vf.c | 25 ++---
>  1 file changed, 18 insertions(+), 7 deletions(-)
> 
> diff --git a/drivers/net/i40e/i40e_ethdev_vf.c
> b/drivers/net/i40e/i40e_ethdev_vf.c
> index 63dbe14..41097fd 100644
> --- a/drivers/net/i40e/i40e_ethdev_vf.c
> +++ b/drivers/net/i40e/i40e_ethdev_vf.c
> @@ -573,7 +573,7 @@ struct rte_i40evf_xstats_name_off {  {
>   txq_info->vsi_id = vsi_id;
>   txq_info->queue_id = queue_id;
> - if (queue_id < nb_txq) {
> + if (queue_id < nb_txq && txq) {
>   txq_info->ring_len = txq->nb_tx_desc;
>   txq_info->dma_ring_addr = txq->tx_ring_phys_addr;
>   }
> @@ -590,7 +590,7 @@ struct rte_i40evf_xstats_name_off {
>   rxq_info->vsi_id = vsi_id;
>   rxq_info->queue_id = queue_id;
>   rxq_info->max_pkt_size = max_pkt_size;
> - if (queue_id < nb_rxq) {
> + if (queue_id < nb_rxq && rxq) {
>   rxq_info->ring_len = rxq->nb_rx_desc;
>   rxq_info->dma_ring_addr = rxq->rx_ring_phys_addr;
>   rxq_info->databuffer_size =
> @@ -622,11 +622,22 @@ struct rte_i40evf_xstats_name_off {
>   vc_vqci->num_queue_pairs = nb_qp;
> 
>   for (i = 0, vc_qpi = vc_vqci->qpair; i < nb_qp; i++, vc_qpi++) {
> - i40evf_fill_virtchnl_vsi_txq_info(&vc_qpi->txq,
> - vc_vqci->vsi_id, i, dev->data->nb_tx_queues, txq[i]);
> - i40evf_fill_virtchnl_vsi_rxq_info(&vc_qpi->rxq,
> - vc_vqci->vsi_id, i, dev->data->nb_rx_queues,
> - vf->max_pkt_len, rxq[i]);
> + if (!txq)
> + i40evf_fill_virtchnl_vsi_txq_info(&vc_qpi->txq,
> + vc_vqci->vsi_id, i, dev->data->nb_tx_queues,
> + NULL);
> + else
> + i40evf_fill_virtchnl_vsi_txq_info(&vc_qpi->txq,
> + vc_vqci->vsi_id, i, dev->data->nb_tx_queues,
> + txq[i]);

Seems, we can simply to !txq?txq:txq[i] to avoid some duplicate, right?

> + if (!rxq)
> + i40evf_fill_virtchnl_vsi_rxq_info(&vc_qpi->rxq,
> + vc_vqci->vsi_id, i, dev->data->nb_rx_queues,
> + vf->max_pkt_len, NULL);
> + else
> + i40evf_fill_virtchnl_vsi_rxq_info(&vc_qpi->rxq,
> + vc_vqci->vsi_id, i, dev->data->nb_rx_queues,
> + vf->max_pkt_len, rxq[i]);
>   }
>   memset(&args, 0, sizeof(args));
>   args.ops = VIRTCHNL_OP_CONFIG_VSI_QUEUES;
> --
> 1.8.3.1



Re: [dpdk-dev] [DPDK v3] net/ipn3ke: modifications on AFU configurations

2019-06-29 Thread Zhang, Qi Z



> -Original Message-
> From: dev [mailto:dev-boun...@dpdk.org] On Behalf Of Xu, Rosen
> Sent: Thursday, June 27, 2019 6:44 PM
> To: Wei, Dan ; dev@dpdk.org
> Cc: Yigit, Ferruh ; Chen, Santos
> ; sta...@dpdk.org
> Subject: Re: [dpdk-dev] [DPDK v3] net/ipn3ke: modifications on AFU
> configurations
> 
> 
> 
> > -Original Message-
> > From: Wei, Dan
> > Sent: Saturday, June 22, 2019 22:25
> > To: dev@dpdk.org
> > Cc: Yigit, Ferruh ; Chen, Santos
> > ; Wei, Dan ; Xu, Rosen
> > ; sta...@dpdk.org
> > Subject: [DPDK v3] net/ipn3ke: modifications on AFU configurations
> >
> > Modify AFU configurations for new BBS(Blue Bitstream) of A10 on N3000
> > card:
> > - AFU register access: RTL changes the UPL(User Programable Logic
> > which is the container of vBNG IP) base address and the read/write
> > commands of register indirect access.
> > - Poll the INIT_STS register to wait for the vBNG IP and DDR reset 
> > completion.
> > - Refine log for debug: print UPL_version not only for vBNG bit
> > stream, but also for other bit streams.
> >
> > Fixes: c01c748e4ae6 ("net/ipn3ke: add new driver")
> > Cc: rosen...@intel.com
> > Cc: sta...@dpdk.org
> >
> > Signed-off-by: Dan Wei 
> > ---
> Acked-by: Rosen Xu 

Applied to dpdk-next-net-intel.

Thanks
Qi


Re: [dpdk-dev] [PATCH v2] net/i40e: i40e get link status update from ipn3ke

2019-06-29 Thread Zhang, Qi Z



> -Original Message-
> From: Pei, Andy
> Sent: Friday, June 28, 2019 4:33 PM
> To: dev@dpdk.org
> Cc: Pei, Andy ; Zhang, Qi Z ; Wu,
> Jingjing ; Xing, Beilei ; Yigit,
> Ferruh ; Xu, Rosen ; Ye,
> Xiaolong ; Zhang, Roy Fan
> ; sta...@dpdk.org
> Subject: [PATCH v2] net/i40e: i40e get link status update from ipn3ke
> 
> Add switch_mode argument for i40e PF to specify the specific FPGA that i40e
> PF is connected to. i40e PF get link status update via the connected FPGA.
> 
> Signed-off-by: Andy Pei 
> ---


> @@ -2799,6 +2913,10 @@ void i40e_flex_payload_reg_set_default(struct
> i40e_hw *hw)
>   else
>   update_link_aq(hw, &link, enable_lse, wait_to_complete);
> 
> + devargs = pci_dev->device.devargs;
> + if (devargs)
> + i40e_pf_linkstatus_get_from_switch_ethdev(devargs, &link);

It's not necessary to check devargs every time we do i40e_dev_link_update, 
its better initialize the ipn3ke mode during initialization (add some field in 
i40e_adapter maybe), so we can reuse the result at runtime

> +
..


[dpdk-dev] [Bug 114] rte_rand() is not thread-safe but not documented as such

2019-06-29 Thread bugzilla
https://bugs.dpdk.org/show_bug.cgi?id=114

Mattias Rönnblom (mattias.ronnb...@ericsson.com) changed:

   What|Removed |Added

 Resolution|--- |FIXED
 Status|CONFIRMED   |RESOLVED
   Target Milestone|--- |19.08

--- Comment #1 from Mattias Rönnblom (mattias.ronnb...@ericsson.com) ---
Fixed by commit 3f002f06961262667694171c20cb3443be6017c1.

-- 
You are receiving this mail because:
You are the assignee for the bug.